﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace ScenarioLanguage
{
    using System.Xml.Serialization;
    using System.Xml;
    using System.Xml.Linq;
    using System.Diagnostics;

    // 
    // This source code was auto-generated by xsd, Version=4.6.1055.0.
    // 


    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class scenario
    {
        private scenarioDefinitions definitionsField;

        private scenarioMetadata metadataField;

        private dialogue[][] sequenceField;

        private int versionField;

        private bool versionFieldSpecified;

        private string schemaVersionField;

        private string configidrefField;

        /// <remarks/>
        public scenarioDefinitions definitions
        {
            get
            {
                return this.definitionsField;
            }
            set
            {
                this.definitionsField = value;
            }
        }

        /// <remarks/>
        public scenarioMetadata metadata
        {
            get
            {
                return this.metadataField;
            }
            set
            {
                this.metadataField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("interleave", IsNullable = false)]
        [XmlArrayItem("dialogue", IsNullable = false, NestingLevel = 1)]
        public dialogue[][] sequence
        {
            get
            {
                return this.sequenceField;
            }
            set
            {
                this.sequenceField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public int version
        {
            get
            {
                return this.versionField;
            }
            set
            {
                this.versionField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool versionSpecified
        {
            get
            {
                return this.versionFieldSpecified;
            }
            set
            {
                this.versionFieldSpecified = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public string schemaVersion
        {
            get
            {
                return this.schemaVersionField;
            }
            set
            {
                this.schemaVersionField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public string configidref
        {
            get
            {
                return this.configidrefField;
            }
            set
            {
                this.configidrefField = value;
            }
        }
    }

    /// <remarks/>



    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class scenarioDefinitions
    {

        private scenarioDefinitionsCharacter[] charactersField;

        private scenarioDefinitionsParameters parametersField;

        private definitionType[] propertiesField;

        /// <remarks/>
        [XmlArrayItem("character", IsNullable = false)]
        public scenarioDefinitionsCharacter[] characters
        {
            get
            {
                return this.charactersField;
            }
            set
            {
                this.charactersField = value;
            }
        }

        /// <remarks/>
        public scenarioDefinitionsParameters parameters
        {
            get
            {
                return this.parametersField;
            }
            set
            {
                this.parametersField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("property", IsNullable = false)]
        public definitionType[] properties
        {
            get
            {
                return this.propertiesField;
            }
            set
            {
                this.propertiesField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class scenarioDefinitionsCharacter
    {

        private string idField;

        private string nameField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string id
        {
            get
            {
                return this.idField;
            }
            set
            {
                this.idField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public string name
        {
            get
            {
                return this.nameField;
            }
            set
            {
                this.nameField = value;
            }
        }
    }

    /// <remarks/>



    [DebuggerDisplay("id = {idField}, text = '{textField.Value}'")]
    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class statementType
    {

        private stringWithXMLAttributes textField;

        private editingData editingDataField;

        private singleConditionType preconditionsField;

        private parameterEffects parameterEffectsField;

        private object[] propertyValuesField;

        private statementTypeResponse[] responsesField;

        private string idField;

        private bool endField;

        private bool endFieldSpecified;

        /// <remarks/>
        public stringWithXMLAttributes text
        {
            get
            {
                return this.textField;
            }
            set
            {
                this.textField = value;
            }
        }

        /// <remarks/>
        public editingData editingData
        {
            get
            {
                return this.editingDataField;
            }
            set
            {
                this.editingDataField = value;
            }
        }

        /// <remarks/>
        public singleConditionType preconditions
        {
            get
            {
                return this.preconditionsField;
            }
            set
            {
                this.preconditionsField = value;
            }
        }

        /// <remarks/>
        public parameterEffects parameterEffects
        {
            get
            {
                return this.parameterEffectsField;
            }
            set
            {
                this.parameterEffectsField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("characterPropertyValue", typeof(propertyValuesCharacterPropertyValue), IsNullable = false)]
        [XmlArrayItem("propertyValue", typeof(propertyValuesPropertyValue), IsNullable = false)]
        public object[] propertyValues
        {
            get
            {
                return this.propertyValuesField;
            }
            set
            {
                this.propertyValuesField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("response", IsNullable = false)]
        public statementTypeResponse[] responses
        {
            get
            {
                return this.responsesField;
            }
            set
            {
                this.responsesField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string id
        {
            get
            {
                return this.idField;
            }
            set
            {
                this.idField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public bool end
        {
            get
            {
                return this.endField;
            }
            set
            {
                this.endField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool endSpecified
        {
            get
            {
                return this.endFieldSpecified;
            }
            set
            {
                this.endFieldSpecified = value;
            }
        }
    }

    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class stringWithXMLAttributes
    {
        //! veg modified (XmlAttribute does not compile on PCL).
        // 
        //private XmlAttribute[] anyAttrField;

        private string valueField;

        //! veg modified (XmlAttribute does not compile on PCL).
        // 
        //[XmlAny]
        //public XmlAttribute[] AnyAttr
        //{
        //    get
        //    {
        //        return this.anyAttrField;
        //    }
        //    set
        //    {
        //        this.anyAttrField = value;
        //    }
        //}

        [XmlText]
        public string Value
        {
            get
            {
                return this.valueField;
            }
            set
            {
                this.valueField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class editingData
    {

        private editingDataPosition positionField;

        private stringWithXMLAttributes commentField;

        /// <remarks/>
        public editingDataPosition position
        {
            get
            {
                return this.positionField;
            }
            set
            {
                this.positionField = value;
            }
        }

        /// <remarks/>
        public stringWithXMLAttributes comment
        {
            get
            {
                return this.commentField;
            }
            set
            {
                this.commentField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class editingDataPosition
    {

        private double xField;

        private double yField;

        /// <remarks/>
        public double x
        {
            get
            {
                return this.xField;
            }
            set
            {
                this.xField = value;
            }
        }

        /// <remarks/>
        public double y
        {
            get
            {
                return this.yField;
            }
            set
            {
                this.yField = value;
            }
        }
    }

    /// <remarks/>

    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class singleConditionType
    {

        private object itemField;

        private ItemChoiceType itemElementNameField;

        /// <remarks/>
        [XmlElement("and", typeof(conditionsTypeAndCondition))]
        [XmlElement("characterCondition", typeof(conditionsTypeCharacterCondition))]
        [XmlElement("condition", typeof(conditionsTypeCondition))]
        [XmlElement("or", typeof(conditionsTypeOrCondition))]
        [XmlChoiceIdentifier("ItemElementName")]
        public object Item
        {
            get
            {
                return this.itemField;
            }
            set
            {
                this.itemField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public ItemChoiceType ItemElementName
        {
            get
            {
                return this.itemElementNameField;
            }
            set
            {
                this.itemElementNameField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class conditionsType
    {
        private object[] itemsField;

        private ItemsChoiceType[] itemsElementNameField;

        /// <remarks/>
        [XmlElement("and", typeof(conditionsTypeAndCondition))]
        [XmlElement("characterCondition", typeof(conditionsTypeCharacterCondition))]
        [XmlElement("condition", typeof(conditionsTypeCondition))]
        [XmlElement("or", typeof(conditionsTypeOrCondition))]
        [XmlChoiceIdentifier("ItemsElementName")]
        public object[] Items
        {
            get
            {
                return this.itemsField;
            }
            set
            {
                this.itemsField = value;
            }
        }

        /// <remarks/>
        [XmlElement("ItemsElementName")]
        [XmlIgnore()]
        public ItemsChoiceType[] ItemsElementName
        {
            get
            {
                return this.itemsElementNameField;
            }
            set
            {
                this.itemsElementNameField = value;
            }
        }
    }

    /// <summary>
    /// The conditions and condition.
    /// 
    /// veg: added manually to be able to keep statements apart from each other.
    /// </summary>
    public partial class conditionsTypeAndCondition : conditionsType
    {

    }

    /// <summary>
    /// The conditions or condition.
    /// 
    /// veg: added manually to be able to keep statements apart from each other.
    /// </summary>
    public partial class conditionsTypeOrCondition : conditionsType
    {

    }

    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class conditionsTypeCharacterCondition : conditionsTypeCondition
    {
        // MvG derived from base class.
        private string characteridrefField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string characteridref
        {
            get
            {
                return this.characteridrefField;
            }
            set
            {
                this.characteridrefField = value;
            }
        }
    }

    /// <remarks/>


    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public enum relationalOperator
    {

        /// <remarks/>
        equalTo,

        /// <remarks/>
        notEqualTo,

        /// <remarks/>
        lessThanEqualTo,

        /// <remarks/>
        lessThan,

        /// <remarks/>
        greaterThan,

        /// <remarks/>
        greaterThanEqualTo,
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class conditionsTypeCondition
    {
        private string idrefField;

        private string textField;

        private relationalOperator operatorField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }

        [XmlAttribute()]
        public relationalOperator @operator
        {
            get
            {
                return this.operatorField;
            }
            set
            {
                this.operatorField = value;
            }
        }

        [XmlText]
        public string value
        {
            get
            {
                return textField;
            }
            set
            {
                this.textField = value;
            }

        }
    }

    /// <remarks/>


    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace", IncludeInSchema = false)]
    public enum ItemsChoiceType
    {

        /// <remarks/>
        and,

        /// <remarks/>
        characterCondition,

        /// <remarks/>
        condition,

        /// <remarks/>
        or,
    }

    /// <remarks/>


    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace", IncludeInSchema = false)]
    public enum ItemChoiceType
    {

        /// <remarks/>
        and,

        /// <remarks/>
        characterCondition,

        /// <remarks/>
        condition,

        /// <remarks/>
        or,
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class parameterEffects
    {

        private parameterEffect[] userDefinedField;

        private object[] fixedField;

        /// <remarks/>
        [XmlArrayItem("parameterEffect", IsNullable = false)]
        public parameterEffect[] userDefined
        {
            get
            {
                return this.userDefinedField;
            }
            set
            {
                this.userDefinedField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("characterParameterEffect", typeof(parameterEffectsCharacterParameterEffect), IsNullable = false)]
        [XmlArrayItem("parameterEffect", typeof(parameterEffect), IsNullable = false)]
        public object[] @fixed
        {
            get
            {
                return this.fixedField;
            }
            set
            {
                this.fixedField = value;
            }
        }
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class parameterEffect
    {
        private string idrefField;

        private assignmentOperator operatorField;

        private string textField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public assignmentOperator @operator
        {
            get
            {
                return this.operatorField;
            }
            set
            {
                this.operatorField = value;
            }
        }

        [XmlText]
        public string value
        {
            get
            {
                return textField;
            }
            set
            {
                this.textField = value;
            }

        }
    }

    /// <remarks/>


    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public enum assignmentOperator
    {

        /// <remarks/>
        assign,

        /// <remarks/>
        addAssign,

        /// <remarks/>
        subtractAssign,
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class parameterEffectsCharacterParameterEffect : parameterEffect
    {
        // veg derived from base class.
        private string characteridrefField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string characteridref
        {
            get
            {
                return this.characteridrefField;
            }
            set
            {
                this.characteridrefField = value;
            }
        }
    }

    /// <remarks/>

    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class propertyValuesCharacterPropertyValue : propertyValuesPropertyValue
    {
        // MvG derived from base class.
        private string characteridrefField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string characteridref
        {
            get
            {
                return this.characteridrefField;
            }
            set
            {
                this.characteridrefField = value;
            }
        }
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class propertyValuesPropertyValue
    {
        private string initialValueField;

        private string idrefField;

        /// <remarks/>
        [XmlText]
        public string initialValue
        {
            get
            {
                return this.initialValueField;
            }
            set
            {
                this.initialValueField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }
    }

    /// <remarks/>



    [DebuggerDisplay("id = {idref}")]
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class statementTypeResponse
    {

        private string idrefField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }
    }

    /// <remarks/>




    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeType
    {

        private object itemField;

        /// <remarks/>
        [XmlElement("boolean", typeof(domainDataTypeTypeBoolean))]
        [XmlElement("enumeration", typeof(domainDataTypeTypeEnumeration))]
        [XmlElement("extension", typeof(domainDataTypeTypeExtension))]
        [XmlElement("integer", typeof(domainDataTypeTypeInteger))]
        [XmlElement("string", typeof(domainDataTypeTypeString))]
        public object Item
        {
            get
            {
                return this.itemField;
            }
            set
            {
                this.itemField = value;
            }
        }
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeTypeBoolean
    {

        private bool defaultField;

        private bool defaultFieldSpecified;

        /// <remarks/>
        public bool @default
        {
            get
            {
                return this.defaultField;
            }
            set
            {
                this.defaultField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool defaultSpecified
        {
            get
            {
                return this.defaultFieldSpecified;
            }
            set
            {
                this.defaultFieldSpecified = value;
            }
        }
    }

    /// <remarks/>




    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeTypeEnumeration
    {

        private string[] optionField;

        private string defaultField;

        /// <remarks/>
        [XmlElement("option")]
        public string[] option
        {
            get
            {
                return this.optionField;
            }
            set
            {
                this.optionField = value;
            }
        }

        /// <remarks/>
        public string @default
        {
            get
            {
                return this.defaultField;
            }
            set
            {
                this.defaultField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeTypeExtension
    {

        private domainDataTypeType equivalentTypeField;

        //! veg modified (XmlElement does not compile on PCL).
        // 
        //private XmlElement anyField;

        /// <remarks/>
        public domainDataTypeType equivalentType
        {
            get
            {
                return this.equivalentTypeField;
            }
            set
            {
                this.equivalentTypeField = value;
            }
        }

        /// <remarks/>
        //! veg modified (XmlElement does not compile on PCL).
        // 
        //[XmlAnyElement]
        //public XmlElement Any
        //{
        //    get
        //    {
        //        return this.anyField;
        //    }
        //    set
        //    {
        //        this.anyField = value;
        //    }
        //}
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeTypeInteger
    {

        private int defaultField;

        private bool defaultFieldSpecified;

        private int minimumField;

        private bool minimumFieldSpecified;

        private int maximumField;

        private bool maximumFieldSpecified;

        /// <remarks/>
        public int @default
        {
            get
            {
                return this.defaultField;
            }
            set
            {
                this.defaultField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool defaultSpecified
        {
            get
            {
                return this.defaultFieldSpecified;
            }
            set
            {
                this.defaultFieldSpecified = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public int minimum
        {
            get
            {
                return this.minimumField;
            }
            set
            {
                this.minimumField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool minimumSpecified
        {
            get
            {
                return this.minimumFieldSpecified;
            }
            set
            {
                this.minimumFieldSpecified = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public int maximum
        {
            get
            {
                return this.maximumField;
            }
            set
            {
                this.maximumField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool maximumSpecified
        {
            get
            {
                return this.maximumFieldSpecified;
            }
            set
            {
                this.maximumFieldSpecified = value;
            }
        }

    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class domainDataTypeTypeString
    {

        private string defaultField;

        /// <remarks/>
        public string @default
        {
            get
            {
                return this.defaultField;
            }
            set
            {
                this.defaultField = value;
            }
        }
    }

    /// <remarks/>
    public partial class definitionType
    {

        private stringWithXMLAttributes descriptionField;

        private domainDataTypeType typeField;

        private string idField;

        private string nameField;

        /// <remarks/>
        public stringWithXMLAttributes description
        {
            get
            {
                return this.descriptionField;
            }
            set
            {
                this.descriptionField = value;
            }
        }

        /// <remarks/>
        public domainDataTypeType type
        {
            get
            {
                return this.typeField;
            }
            set
            {
                this.typeField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string id
        {
            get
            {
                return this.idField;
            }
            set
            {
                this.idField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public string name
        {
            get
            {
                return this.nameField;
            }
            set
            {
                this.nameField = value;
            }
        }
    }

    /// <remarks/>

    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class scenarioDefinitionsParameters
    {

        private definitionType[] userDefinedField;

        private definitionType[] fixedField;

        /// <remarks/>
        [XmlArrayItem("parameter", IsNullable = false)]
        public definitionType[] userDefined
        {
            get
            {
                return this.userDefinedField;
            }
            set
            {
                this.userDefinedField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("parameter", IsNullable = false)]
        public definitionType[] @fixed
        {
            get
            {
                return this.fixedField;
            }
            set
            {
                this.fixedField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class scenarioMetadata
    {

        private string nameField;

        private string dateField;

        private stringWithXMLAttributes descriptionField;

        private scenarioMetadataDifficulty difficultyField;

        private scenarioMetadataInitialParameterValues initialParameterValuesField;

        private object[] propertyValuesField;

        /// <remarks/>
        public string name
        {
            get
            {
                return this.nameField;
            }
            set
            {
                this.nameField = value;
            }
        }

        /// <remarks/>
        public string date
        {
            get
            {
                return this.dateField;
            }
            set
            {
                this.dateField = value;
            }
        }

        /// <remarks/>
        public stringWithXMLAttributes description
        {
            get
            {
                return this.descriptionField;
            }
            set
            {
                this.descriptionField = value;
            }
        }

        /// <remarks/>
        public scenarioMetadataDifficulty difficulty
        {
            get
            {
                return this.difficultyField;
            }
            set
            {
                this.difficultyField = value;
            }
        }

        /// <remarks/>
        public scenarioMetadataInitialParameterValues initialParameterValues
        {
            get
            {
                return this.initialParameterValuesField;
            }
            set
            {
                this.initialParameterValuesField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("characterPropertyValue", typeof(propertyValuesCharacterPropertyValue), IsNullable = false)]
        [XmlArrayItem("propertyValue", typeof(propertyValuesPropertyValue), IsNullable = false)]
        public object[] propertyValues
        {
            get
            {
                return this.propertyValuesField;
            }
            set
            {
                this.propertyValuesField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public enum scenarioMetadataDifficulty
    {

        /// <remarks/>
        very_easy,

        /// <remarks/>
        easy,

        /// <remarks/>
        medium,

        /// <remarks/>
        difficult,

        /// <remarks/>
        very_difficult,
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class scenarioMetadataInitialParameterValues
    {
        private object[] userDefinedField;

        private object[] fixedField;

        /// <remarks/>
        [XmlArrayItem("characterParameterValue", typeof(simpleParameterValuesCharacterParameterValue), IsNullable = false)]
        [XmlArrayItem("parameterValue", typeof(simpleParameterValuesParameterValue), IsNullable = false)]
        public object[] userDefined
        {
            get
            {
                return this.userDefinedField;
            }
            set
            {
                this.userDefinedField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("characterParameterValue", typeof(simpleParameterValuesCharacterParameterValue), IsNullable = false)]
        [XmlArrayItem("parameterValue", typeof(simpleParameterValuesParameterValue), IsNullable = false)]
        public object[] @fixed
        {
            get
            {
                return this.fixedField;
            }
            set
            {
                this.fixedField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class simpleParameterValuesCharacterParameterValue
    {
        // veg Added
        // 
        private string initialValueField;

        private string idrefField;

        private string characteridrefField;

        /// <remarks/>
        [XmlText()]
        // veg Added
        // 
        public string initialValue
        {
            get
            {
                return this.initialValueField;
            }
            set
            {
                this.initialValueField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string characteridref
        {
            get
            {
                return this.characteridrefField;
            }
            set
            {
                this.characteridrefField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class simpleParameterValuesParameterValue
    {
        // veg Added
        // 
        private string initialValueField;

        private string idrefField;

        /// <remarks/>
        [XmlText()]
        // veg Added
        // 
        public string initialValue
        {
            get
            {
                return this.initialValueField;
            }
            set
            {
                this.initialValueField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }
    }

    /// <remarks/>
    [DebuggerDisplay("id = {idField}, subject = '{subjectField}', optional = {optionalField}")]

    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class dialogue
    {

        private string subjectField;

        private editingData editingDataField;

        private dialogueStart[] startsField;

        private dialogueStatements statementsField;

        private string idField;

        private bool optionalField;

        /// <remarks/>
        public string subject
        {
            get
            {
                return this.subjectField;
            }
            set
            {
                this.subjectField = value;
            }
        }

        /// <remarks/>
        public editingData editingData
        {
            get
            {
                return this.editingDataField;
            }
            set
            {
                this.editingDataField = value;
            }
        }

        /// <remarks/>
        [XmlArrayItem("start", IsNullable = false)]
        public dialogueStart[] starts
        {
            get
            {
                return this.startsField;
            }
            set
            {
                this.startsField = value;
            }
        }

        /// <remarks/>
        public dialogueStatements statements
        {
            get
            {
                return this.statementsField;
            }
            set
            {
                this.statementsField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string id
        {
            get
            {
                return this.idField;
            }
            set
            {
                this.idField = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public bool optional
        {
            get
            {
                return this.optionalField;
            }
            set
            {
                this.optionalField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class dialogueStart
    {

        private string idrefField;

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string idref
        {
            get
            {
                return this.idrefField;
            }
            set
            {
                this.idrefField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class dialogueStatements
    {

        private statementType[] itemsField;

        private ItemsChoiceType1[] itemsElementNameField;

        /// <remarks/>
        [XmlElement("computerStatement", typeof(dialogueComputerStatement))]
        [XmlElement("playerStatement", typeof(dialoguePlayerStatement))]
        [XmlElement("situationStatement", typeof(dialogueSituationStatement))]
        [XmlChoiceIdentifier("ItemsElementName")]
        public statementType[] Items
        {
            get
            {
                return this.itemsField;
            }
            set
            {
                this.itemsField = value;
            }
        }

        /// <remarks/>
        [XmlElement("ItemsElementName")]
        [XmlIgnore()]
        public ItemsChoiceType1[] ItemsElementName
        {
            get
            {
                return this.itemsElementNameField;
            }
            set
            {
                this.itemsElementNameField = value;
            }
        }
    }

    /// <summary>
    /// A dialogue player statement.
    /// 
    /// veg: added manually to be able to keep statements apart from each other.
    /// </summary>
    public partial class dialoguePlayerStatement : statementType
    {
    }

    /// <summary>
    /// A dialog situation statement.
    /// 
    /// veg: added manually to be able to keep statements apart from each other.
    /// </summary>
    public partial class dialogueSituationStatement : statementType
    {
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    public partial class dialogueComputerStatement : statementType
    {

        private bool allowInterleaveField;

        private bool allowInterleaveFieldSpecified;

        private bool jumpPointField;

        private bool jumpPointFieldSpecified;

        private bool allowDialogueEndField;

        private bool allowDialogueEndFieldSpecified;

        private bool initsField;

        private bool initsFieldSpecified;

        private string characteridrefField;

        /// <remarks/>
        [XmlAttribute()]
        public bool allowInterleave
        {
            get
            {
                if (!this.allowInterleaveFieldSpecified && this.jumpPointFieldSpecified)
                {
                    return this.jumpPointField;
                }
                else
                {
                    return this.allowInterleaveField;
                }
            }
            set
            {
                this.allowInterleaveField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool allowInterleaveSpecified
        {
            get
            {
                return this.allowInterleaveFieldSpecified || this.jumpPointFieldSpecified;
            }
            set
            {
                this.allowInterleaveFieldSpecified = value;
            }
        }

        /// <remarks>
        /// Deprecated synonym for <see cref="allowInterleave"/>.
        /// </remarks>
        [XmlAttribute()]
        public bool jumpPoint
        {
            get
            {
                return this.jumpPointField;
            }
            set
            {
                this.jumpPointField = value;
            }
        }

        /// <remarks>
        /// Deprecated synonym for <see cref="allowInterleaveSpecified"/>.
        /// </remarks>
        [XmlIgnore()]
        public bool jumpPointSpecified
        {
            get
            {
                return this.jumpPointFieldSpecified;
            }
            set
            {
                this.jumpPointFieldSpecified = value;
            }
        }

        /// <remarks/>
        [XmlAttribute()]
        public bool allowDialogueEnd
        {
            get
            {
                if (!this.allowDialogueEndFieldSpecified && this.initsFieldSpecified)
                {
                    return this.initsField;
                }
                else
                {
                    return this.allowDialogueEndField;
                }
            }
            set
            {
                this.allowDialogueEndField = value;
            }
        }

        /// <remarks/>
        [XmlIgnore()]
        public bool allowDialogueEndSpecified
        {
            get
            {
                return this.allowDialogueEndFieldSpecified || this.initsFieldSpecified;
            }
            set
            {
                this.allowDialogueEndFieldSpecified = value;
            }
        }

        /// <remarks>
        /// Deprecated synonym for <see cref="allowDialogueEnd"/>.
        /// </remarks>
        [XmlAttribute()]
        public bool inits
        {
            get
            {
                return this.initsField;
            }
            set
            {
                this.initsField = value;
            }
        }

        /// <remarks>
        /// Deprecated synonym for <see cref="allowDialogueEndSpecified"/>.
        /// </remarks>
        [XmlIgnore()]
        public bool initsSpecified
        {
            get
            {
                return this.initsFieldSpecified;
            }
            set
            {
                this.initsFieldSpecified = value;
            }
        }

        /// <remarks/>
        [XmlAttribute(DataType = "NCName")]
        public string characteridref
        {
            get
            {
                return this.characteridrefField;
            }
            set
            {
                this.characteridrefField = value;
            }
        }
    }

    /// <remarks/>
    [XmlType(Namespace = "http://uudsl.github.io/scenario/namespace", IncludeInSchema = false)]
    public enum ItemsChoiceType1
    {

        /// <remarks/>
        computerStatement,

        /// <remarks/>
        playerStatement,

        /// <remarks/>
        situationStatement,
    }

    /// <remarks/>
    [XmlType(AnonymousType = true, Namespace = "http://uudsl.github.io/scenario/namespace")]
    [XmlRoot(Namespace = "http://uudsl.github.io/scenario/namespace", IsNullable = false)]
    public partial class propertyValues
    {

        private object[] itemsField;

        /// <remarks/>
        [XmlElement("characterPropertyValue", typeof(propertyValuesCharacterPropertyValue))]
        [XmlElement("propertyValue", typeof(propertyValuesPropertyValue))]
        public object[] Items
        {
            get
            {
                return this.itemsField;
            }
            set
            {
                this.itemsField = value;
            }
        }
    }
}